/*
 * This file is part of the MDR library.
 * Copyright (C) 2013-2023 Mateusz Viste
 */

#include <i86.h>
#include <string.h>

#include <mdr\cout.h>

void mdr_coutraw_puts(const char *s) {
  unsigned short s_seg = FP_SEG(s);
  unsigned short s_off = FP_OFF(s);
  //unsigned short slen = strlen(s);
  _asm {
    push bx
    push cx
    push dx
    push ds
    push es

    /* set DS and ES to source string */
    mov ax, s_seg
    mov ds, ax
    mov es, ax

    /* compute strlen of s and put it in cx */
    mov di, s_off
    xor al, al /* look for 0 char */
    mov cx, 0xffff
    repnz scasb
    sub di, s_off
    mov cx, di

    /* ah=0x40 -- "write to file or device" */
    mov ah, 0x40
    mov dx, s_off    /* source string */
    mov bx, 0        /* file handle 0 is stdout */
    /* mov cx, slen */ /* bytes count */
    int 0x21

    /* append a CR/LF terminator */
    mov ah, 2
    mov dl, 13
    int 0x21
    mov dl, 10
    int 0x21

    pop es
    pop ds
    pop dx
    pop cx
    pop bx
  }
}
